#ifndef SIMULATION_H
#define SIMULATION_H

#include <vector>
#include "behavior.h"
#include "team.h"

class MapScene;

class Simulation
{
private:
    MapScene *p_map;
    std::vector<Dude*> m_dudes;
    std::vector<Team> m_teams;
public:
    Simulation(MapScene *_map, std::vector<BehaviorFunction> &_behaviors);
    MapScene* getMap() { return (MapScene*) p_map; }
    int getPopulation(){return m_dudes.size();}

    /**
     * @brief update runs one step of simulation
     */
    void update();
    void handleAction(Dude* dude);
};

#endif // SIMULATION_H
